package cn.com.infosec.jce.oscca;

import java.security.MessageDigest;

public class OSCCAMessageDigest {
   private static byte[] abGxGy;

   static {
      byte[] var10000 = SM2Util.gma.toByteArray();
      byte[] var0 = new byte[32];
      System.arraycopy(var10000, 1, var0, 0, 32);
      byte[] var1 = SM2Util.gmb.toByteArray();
      byte[] var2 = SM2Util.gmgx.toByteArray();
      byte[] var3 = SM2Util.gmgy.toByteArray();
      byte[] var4;
      var10000 = var4 = new byte[32];
      byte[] var10001 = var1;
      byte[] var10002 = var1;
      byte[] var10004 = var0;
      System.arraycopy(var3, 1, var4, 0, 32);
      abGxGy = var0 = new byte[32 + var1.length + var2.length + 32];
      System.arraycopy(var10004, 0, var0, 0, 32);
      var0 = abGxGy;
      int var6 = var1.length;
      System.arraycopy(var10002, 0, var0, 32, var6);
      int var5;
      int var8 = var5 = 32 + var10001.length;
      var10002 = var2;
      byte[] var10003 = var2;
      var1 = abGxGy;
      int var7 = var2.length;
      System.arraycopy(var10003, 0, var1, var5, var7);
      var5 = var8 + var10002.length;
      System.arraycopy(var10000, 0, abGxGy, var5, 32);
   }

   public static byte[] SM3Digest(byte[] puid, byte[] x, byte[] y, byte[] msg) {
      return puid == null ? SM3.SM3Digest(msg) : SM3.SM3Digest(connect(SM3.SM3Digest(connect(puid, x, y)), msg));
   }

   public static byte[] SHADigest(String alg, byte[] puid, byte[] x, byte[] y, byte[] msg) {
      MessageDigest var5 = MessageDigest.getInstance(alg, "INFOSEC");
      if (puid == null) {
         return var5.digest(msg);
      } else {
         String var10000 = alg;
         byte[] alg1 = connect(puid, x, y);
         return var5.digest(connect(!var10000.endsWith("256") ? MessageDigest.getInstance("SHA256", "INFOSEC").digest(alg1) : var5.digest(alg1), msg));
      }
   }

   private static byte[] connect(byte[] Z, byte[] M) {
      byte[] var2;
      byte[] var10000 = var2 = new byte[Z.length + M.length];
      byte[] var10001 = M;
      byte[] var10003 = Z;
      byte[] var10004 = Z;
      int Z1 = Z.length;
      System.arraycopy(var10004, 0, var2, 0, Z1);
      Z1 = var10003.length;
      int M1 = M.length;
      System.arraycopy(var10001, 0, var2, Z1, M1);
      return var10000;
   }

   private static byte[] connect(byte[] puid, byte[] x, byte[] y) {
      byte[] var3;
      byte[] var10000 = var3 = new byte[puid.length + 2 + abGxGy.length + x.length + y.length];
      byte[] var10001 = y;
      byte[] var10002 = y;
      byte[] var10003 = puid;
      byte[] var10004 = puid;
      byte[] var10005 = puid;
      int puid1 = puid.length * 8;
      System.arraycopy(new byte[]{(byte)(puid1 >> 8 & 255), (byte)(puid1 & 255)}, 0, var3, 0, 2);
      puid1 = var10005.length;
      System.arraycopy(var10004, 0, var3, 2, puid1);
      int var7 = puid1 = 2 + var10003.length;
      var10004 = abGxGy;
      int y1 = var10004.length;
      System.arraycopy(var10004, 0, var3, puid1, y1);
      var7 = puid1 = var7 + abGxGy.length;
      var10004 = x;
      var10005 = x;
      int x1 = x.length;
      System.arraycopy(var10005, 0, var3, puid1, x1);
      puid1 = var7 + var10004.length;
      x1 = var10002.length;
      System.arraycopy(var10001, 0, var3, puid1, x1);
      return var10000;
   }

   public static void main(String[] args) {
      byte[] args1 = "11111111".getBytes();
      SM3Digest((byte[])null, (byte[])null, (byte[])null, args1);
   }
}
